
#line 530 "../../blib/lib/PDL/PP.pm"
/*
 * THIS FILE WAS GENERATED BY PDL::PP! Do not modify!
 */

#define PDL_COMMENT(comment)
PDL_COMMENT("This preprocessor symbol is used to add commentary in the PDL  ")
PDL_COMMENT("autogenerated code. Normally, one would use typical C-style    ")
PDL_COMMENT("multiline comments (i.e. /* comment */). However, because such ")
PDL_COMMENT("comments do not nest, it's not possible for PDL::PP users to   ")
PDL_COMMENT("comment-out sections of code using multiline comments, as is   ")
PDL_COMMENT("often the practice when debugging, for example. So, when you   ")
PDL_COMMENT("see something like this:                                       ")
PDL_COMMENT("                                                               ")
                PDL_COMMENT("Memory access")
PDL_COMMENT("                                                               ")
PDL_COMMENT("just think of it as a C multiline comment like:                ")
PDL_COMMENT("                                                               ")
PDL_COMMENT("   /* Memory access */                                         ")

#define PDL_FREE_CODE(trans, destroy, comp_free_code, ntpriv_free_code) \
    if (destroy) { \
	comp_free_code \
    } \
    if ((trans)->dims_redone) { \
	ntpriv_free_code \
    }

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "pdl.h"
#include "pdlcore.h"
#define PDL PDL_Transform
extern Core* PDL; PDL_COMMENT("Structure hold core C functions")
static int __pdl_boundscheck = 0;

#if ! 1
# define PP_INDTERM(max, at) at
#else
# define PP_INDTERM(max, at) (__pdl_boundscheck? PDL->safe_indterm(max,at, __FILE__, __LINE__) : at)
#endif
#line 45 "pp-map.c"
#include <sys/time.h>


/*
 * Singular-value decomposition code is borrowed from
 * MatrixOps -- cut-and-pasted here because of linker trouble.
 * It's used by the auxiliary matrix manipulation code, below.
 *
 */

static inline void pdl_xform_svd(PDL_Double *W, PDL_Double *Z, int nRow, int nCol)
{
  int i, j, k, EstColRank, RotCount, SweepCount, slimit;
  PDL_Double eps, e2, tol, vt, p, h2, x0, y0, q, r, c0, s0, c2, d1, d2;
  eps = 1e-6;
  slimit = nCol/4;
  if (slimit < 6.0)
    slimit = 6;
  SweepCount = 0;
  e2 = 10.0*nRow*eps*eps;
  tol = eps*.1;
  EstColRank = nCol;
  for (i=0; i<nCol; i++) {
    for (j=0; j<nCol; j++) {
      W[nCol*(nRow+i)+j] = 0.0;
    }
    W[nCol*(nRow+i)+i] = 1.0;  /* rjrw 7/7/99: moved this line out of j loop */
  }
  RotCount = EstColRank*(EstColRank-1)/2;
  while (RotCount != 0 && SweepCount <= slimit)
    {
      RotCount = EstColRank*(EstColRank-1)/2;
      SweepCount++;
      for (j=0; j<EstColRank-1; j++)
        {
          for (k=j+1; k<EstColRank; k++)
            {
              p = q = r = 0.0;
              for (i=0; i<nRow; i++)
                {
                  x0 = W[nCol*i+j]; y0 = W[nCol*i+k];
                  p += x0*y0; q += x0*x0; r += y0*y0;
                }
              Z[j] = q; Z[k] = r;
              if (q >= r)
                {
                  if (q<=e2*Z[0] || fabs(p)<=tol*q) RotCount--;
                  else
                    {
                      p /= q; r = 1 - r/q; vt = sqrt(4*p*p+r*r);
                      c0 = sqrt(fabs(.5*(1+r/vt))); s0 = p/(vt*c0);
                      for (i=0; i<nRow+nCol; i++)
                        {
                          d1 = W[nCol*i+j]; d2 = W[nCol*i+k];
                          W[nCol*i+j] = d1*c0+d2*s0; W[nCol*i+k] = -d1*s0+d2*c0;
                        }
                    }
                }
              else
                {
                  p /= r; q = q/r-1; vt = sqrt(4*p*p+q*q);
                  s0 = sqrt(fabs(.5*(1-q/vt)));
                  if (p<0) s0 = -s0;
                  c0 = p/(vt*s0);
                  for (i=0; i<nRow+nCol; i++)
                    {
                      d1 = W[nCol*i+j]; d2 = W[nCol*i+k];
                      W[nCol*i+j] = d1*c0+d2*s0; W[nCol*i+k] = -d1*s0+d2*c0;
                    }
                }
            }
        }
      while (EstColRank>=3 && Z[(EstColRank-1)]<=Z[0]*tol+tol*tol)
        EstColRank--;
    }
}

/*
 * PDL_xform_aux:
 *  This handles the matrix manipulation part of the Jacobian filtered
 *  mapping code.  It's separate from the main code because it's
 *  independent of the data type of the original arrays.
 *
 *Given a pre-allocated workspace  and
 * an integer set of coordinates, generate the discrete Jacobian
 * from the map, pad the singular values, and return the inverse
 * Jacobian, the largest singular value of the Jacobian itself, and
 * the determinant of the original Jacobian.  Boundary values use the
 * asymmetric discrete Jacobian; others use the symmetric discrete Jacobian.
 *
 * The map and workspace must be of type PDL_D.  If the dimensionality is
 * d, then the workspace must have at least 3*n^2+n elements.  The
 * inverse of the padded Jacobian is returned in the first n^2 elements.
 * The determinant of the original Jacobian gets stuffed into the n^2
 * element of the workspace. The largest padded singular value is returned.
 *
 */

static inline PDL_Double PDL_xform_aux ( pdl *map, PDL_Indx *coords, PDL_Double *tmp, PDL_Double sv_min) {
  short ndims;
  PDL_Long i, j, k;
  PDL_Long offset;
  PDL_Double det;
  PDL_Double *jptr;
  PDL_Double *svptr;
  PDL_Double *aptr,*bptr;
  PDL_Double max_sv = 0.0;

  ndims = map->ndims-1;

  /****** Accumulate the Jacobian */
  /* Accumulate the offset into the map array */
  for( i=offset=0; i<ndims; i++)
    offset += coords[i] * map->dimincs[i+1];

  jptr = tmp + ndims*ndims;

  for( i=0; i<ndims; i++) {                    /* Loop over offset direction */
    char bot = (coords[i] <=0);
    char top = (coords[i] >= map->dims[i+1]-1);
    char symmetric = !(bot || top);
    PDL_Double *ohi,*olo;
    PDL_Long diff = map->dimincs[i+1];
    ohi = ((PDL_Double *)map->data) + ( offset + ( top ? 0 : diff ));
    olo = ((PDL_Double *)map->data) + ( offset - ( bot ? 0 : diff ));

    for( j=0; j<ndims; j++) {                 /* Loop over dimension */
       PDL_Double jel =   *ohi - *olo;

       ohi += map->dimincs[0];
       olo += map->dimincs[0];

       if(symmetric)
         jel /= 2;
       *(jptr++) = jel;
    }
  }


  /****** Singular-value decompose the Jacobian
   * The svd routine produces the squares of the singular values,
   * and requires normalization for one of the rotation matrices.
   */

  jptr =   tmp + ndims*ndims;
  svptr = tmp + 3*ndims*ndims;
  pdl_xform_svd(jptr,svptr,ndims,ndims);

  aptr = svptr;
  for (i=0;i<ndims;i++,aptr++)
    *aptr = sqrt(*aptr);


  /* fix-up matrices here */
  bptr = jptr;
  for(i=0; i<ndims;i++) {
    aptr = svptr;
    for(j=0;j<ndims;j++)
     *(bptr++) /= *(aptr++);
  }

  /****** Store the determinant, and pad the singular values as necessary.*/
  aptr = svptr;
  det = 1.0;
  for(i=0;i<ndims;i++) {
    det *= *aptr;
    if(*aptr < sv_min)
      *aptr = sv_min;
    if(*aptr > max_sv )
        max_sv = *aptr;
    aptr++;
  }

  /****** Generate the inverse matrix */
  /* Multiply B-transpose times 1/S times A-transpose. */
  /* since S is diagonal we just divide by the appropriate element. */
  /* */
  aptr = tmp  + ndims*ndims;
  bptr = aptr + ndims*ndims;
  jptr=  tmp;

  for(i=0;i<ndims;i++) {
    for(j=0;j<ndims;j++) {
        *jptr = 0;

        for(k=0;k<ndims;k++)
          *jptr += aptr[j*ndims + k] * bptr[k*ndims + i] / *svptr;

        jptr++;
    }
    svptr++;
  }

 *jptr = det;
  return max_sv;
}


#line 1767 "../../blib/lib/PDL/PP.pm"
typedef struct pdl_params_map {
pdl  *in;pdl  *out;pdl  *map;SV  *boundary;SV  *method;long  big;double  blur;double  sv_min;char  flux;SV  *bv;} pdl_params_map;
#line 247 "pp-map.c"



#line 1778 "../../blib/lib/PDL/PP.pm"
pdl_error pdl_map_readdata(pdl_trans *__privtrans) {
  pdl_error PDL_err = {0, NULL, 0};
  pdl_params_map *__params = __privtrans->params;
  
#line 155 "../../blib/lib/PDL/PP/PDLCode.pm"
PDL_COMMENT("broadcastloop declarations")
int __brcloopval;
register PDL_Indx __tind0,__tind1; PDL_COMMENT("counters along dim")
register PDL_Indx __tnpdls = __privtrans->broadcast.npdls;
PDL_COMMENT("dims here are how many steps along those dims")
register PDL_Indx __tinc0_k0 = PDL_BRC_INC(__privtrans->broadcast.incs,__tnpdls,0,0);
register PDL_Indx __tinc1_k0 = PDL_BRC_INC(__privtrans->broadcast.incs,__tnpdls,0,1);
#line 1790 "../../blib/lib/PDL/PP.pm"

#line 178 "../../blib/lib/PDL/PP/PDLCode.pm"
#ifndef PDL_DECLARE_PARAMS_map_1
#define PDL_DECLARE_PARAMS_map_1(PDL_PARAMTYPE_k0) \
  PDL_DECLARE_PARAMETER(PDL_PARAMTYPE_k0, (__privtrans->vtable->per_pdl_flags[0]), k0, (__privtrans->pdls[0]), 1)
#endif
#line 1797 "../../blib/lib/PDL/PP.pm"
PDL_COMMENT("Start generic loop")
	switch(__privtrans->__datatype) {

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_SB: {
#line 1803 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_SByte)
#line 1810 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_SByte badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 1915 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 1932 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 1940 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 1948 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 2000 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_SByte *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 2099 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 2130 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 2298 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_SByte *dat = ((PDL_SByte *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_SByte *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_SByte *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 2468 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_B: {
#line 2472 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) t

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Byte)
#line 2479 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Byte badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 2584 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 2601 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 2609 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 2617 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 2669 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Byte *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 2768 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 2799 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 2967 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Byte *dat = ((PDL_Byte *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Byte *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Byte *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 3137 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_S: {
#line 3141 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Short)
#line 3148 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Short badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 3253 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 3270 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 3278 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 3286 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 3338 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Short *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 3437 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 3468 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 3636 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Short *dat = ((PDL_Short *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Short *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Short *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 3806 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_US: {
#line 3810 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) t

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Ushort)
#line 3817 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Ushort badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 3922 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 3939 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 3947 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 3955 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 4007 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Ushort *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 4106 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 4137 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 4305 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Ushort *dat = ((PDL_Ushort *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Ushort *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Ushort *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 4475 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_L: {
#line 4479 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Long)
#line 4486 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Long badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 4591 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 4608 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 4616 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 4624 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 4676 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Long *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 4775 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 4806 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 4974 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Long *dat = ((PDL_Long *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Long *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Long *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 5144 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_UL: {
#line 5148 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) t

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_ULong)
#line 5155 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_ULong badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 5260 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 5277 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 5285 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 5293 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 5345 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_ULong *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 5444 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 5475 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 5643 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_ULong *dat = ((PDL_ULong *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_ULong *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_ULong *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 5813 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_IND: {
#line 5817 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Indx)
#line 5824 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Indx badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 5929 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 5946 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 5954 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 5962 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 6014 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Indx *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 6113 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 6144 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 6312 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Indx *dat = ((PDL_Indx *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Indx *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Indx *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 6482 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_ULL: {
#line 6486 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) t

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_ULongLong)
#line 6493 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_ULongLong badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 6598 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 6615 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 6623 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 6631 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 6683 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_ULongLong *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 6782 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 6813 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 6981 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_ULongLong *dat = ((PDL_ULongLong *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_ULongLong *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_ULongLong *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 7151 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_LL: {
#line 7155 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) t
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_LongLong)
#line 7162 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_LongLong badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 7267 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 7284 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 7292 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 7300 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 7352 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_LongLong *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 7451 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 7482 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 7650 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_LongLong *dat = ((PDL_LongLong *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_LongLong *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_LongLong *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 7820 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_F: {
#line 7824 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) f
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Float)
#line 7831 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Float badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 7936 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 7953 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 7961 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 7969 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 8021 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Float *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 8120 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 8151 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 8319 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Float *dat = ((PDL_Float *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Float *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Float *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 8489 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_D: {
#line 8493 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) f
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_Double)
#line 8500 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Double badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 8605 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 8622 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 8630 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 8638 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 8690 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_Double *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 8789 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 8820 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 8988 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_Double *dat = ((PDL_Double *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_Double *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Double *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 9158 "../../blib/lib/PDL/PP.pm"

#line 511 "../../blib/lib/PDL/PP/PDLCode.pm"
case PDL_LD: {
#line 9162 "../../blib/lib/PDL/PP.pm"
#define PDL_IF_GENTYPE_INTEGER(t,f) f
#define PDL_IF_GENTYPE_REAL(t,f) t
#define PDL_IF_GENTYPE_UNSIGNED(t,f) f

#line 504 "../../blib/lib/PDL/PP/PDLCode.pm"
		PDL_DECLARE_PARAMS_map_1(PDL_LDouble)
#line 9169 "../../blib/lib/PDL/PP.pm"
PDL_BROADCASTLOOP_START(
readdata,
__privtrans->broadcast,
__privtrans->vtable,
	k0_datap += __offsp[0];
,
(	,k0_datap += __tinc1_k0 - __tinc0_k0 * __tdims0
),
(	,k0_datap += __tinc0_k0
)
)
{

/*
 * Pixel interpolation & averaging code
 *
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with broadcastloops; broadcasting
 * is handled internally.  To simplify the broadcasting business, any
 * broadcast dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 pdl *in  = __params->in;
 pdl *out = __params->out;
 pdl *map = __params->map;

 PDL_Indx ndims = map->ndims -1; /* Number of dimensions we're working in */
 PDL_Double tmp[3*ndims*ndims+ndims]; /* Workspace for prefrobnication */
 PDL_Indx ovec[ndims];      /* output pixel loop vector                 */
 PDL_Indx ivec[ndims];      /* input pixel loop vector                  */
 PDL_Indx ibvec[ndims];     /* input pixel base offset vector           */
 PDL_Double dvec[ndims];    /* Residual vector for linearization        */
 PDL_Double tvec[ndims];    /* Temporary floating-point vector          */
 PDL_Double acc[in->dims[ndims]]; /* Broadcasted accumulator */
 PDL_Double wgt[in->dims[ndims]]; /* Broadcasted weight accumulator */
 PDL_Double wgt2[in->dims[ndims]]; /* Broadcasted weight accumulator for badval finding */
 char bounds[ndims];        /* Boundary condition packed string */
 PDL_Indx  index_stash[ndims]; /* Stash to store the opening index of dim sample scans */
 char   method;             /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;                 /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_LDouble badval = SvNV(__params->bv);
 #define HANNING_LOOKUP_SIZE 2500
 static PDL_Double hanning_lookup[HANNING_LOOKUP_SIZE + 2];
 static int needs_hanning_calc = 1;
 PDL_Double zeta;
 PDL_Double hanning_offset;

 #define GAUSSIAN_LOOKUP_SIZE 4000
 #define GAUSSIAN_MAXVAL 6.25  /* 2.5 HWHMs (square it) */
 static PDL_Double gaussian_lookup[GAUSSIAN_LOOKUP_SIZE + 2];
 static int needs_gaussian_calc = 1;

 PDL_RETERROR(PDL_err, PDL->make_physical(in));
 PDL_RETERROR(PDL_err, PDL->make_physical(out));
 PDL_RETERROR(PDL_err, PDL->make_physical(map));

/***
 * Fill in the boundary condition array
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__params->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++)
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
        bounds[i] = 0;
        break;
      case '1': case 't': case 'T':               /* truncate */
        bounds[i] = 1;
        break;
      case '2': case 'e': case 'E':               /* extend */
        bounds[i] = 2;
        break;
      case '3': case 'p': case 'P':               /* periodic */
        bounds[i] = 3;
        break;
      case '4': case 'm': case 'M':               /* mirror */
        bounds[i] = 4;
        break;
      default:
        {
          char buf[BUFSIZ];
          sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
          
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 9274 "../../blib/lib/PDL/PP.pm"
;
        }
        break;
      }
    }
  }
 }

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 big    = labs(__params->big);
 if(big <= 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'big' parameter must be >0")
#line 9291 "../../blib/lib/PDL/PP.pm"
;

 blur   = fabs(__params->blur);
 if(blur < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'blur' parameter must be >= 0")
#line 9299 "../../blib/lib/PDL/PP.pm"
;

 sv_min = fabs(__params->sv_min);
 if(sv_min < 0)
   
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","map: 'sv_min' parameter must be >= 0")
#line 9307 "../../blib/lib/PDL/PP.pm"
;

 flux   = __params->flux != 0;

 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__params->method,mlen);

  if(mlen==0)
        method = 'h';
  else switch(*mstr) {
    case 'H':                       method='H'; break;
    case 'h':                       method = 'h';
      if( needs_hanning_calc ) {
         int i;
         for(i=0;i<HANNING_LOOKUP_SIZE;i++) {
           hanning_lookup[i] = 0.5 + 0.5 * cos(3.1415926536 / HANNING_LOOKUP_SIZE * i);
         }
         hanning_lookup[HANNING_LOOKUP_SIZE]   = 0;
         hanning_lookup[HANNING_LOOKUP_SIZE+1] = 0;
         needs_hanning_calc = 0;
      }
      zeta = HANNING_LOOKUP_SIZE / blur;
      hanning_offset = (blur >= 1) ?
                0 :
                0.5 * (1.0 - blur);
      break;

    case 'g': case 'j':             method = 'g';
      zeta = GAUSSIAN_LOOKUP_SIZE / GAUSSIAN_MAXVAL;

      if( needs_gaussian_calc ) {
        int i;
	for(i=0;i<GAUSSIAN_LOOKUP_SIZE;i++) {
	  gaussian_lookup[i] = exp( - i * 1.386294 / zeta );
	}
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE]   = 0;
	gaussian_lookup[GAUSSIAN_LOOKUP_SIZE+1] = 0;
	needs_gaussian_calc = 0;
      }
      break;

    case 'G': case 'J':             method = 'G'; break;
    default:
      {
        char err[80];
        sprintf(err,"Bug in map: unknown method '%c'",*mstr);
        
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",err)
#line 9359 "../../blib/lib/PDL/PP.pm"
;
      }
      break;
    }
 }



 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */

 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
   ovec[i] = 0;

 map_ptr = (PDL_Double *)(map->data);


/* Main pixel loop (iterates over pixels in the output plane) */
 do {
   PDL_Indx psize;    PDL_Indx i_off;    PDL_Indx j;        char t_vio;        char carry;     
   /* Prefrobnicate the transformation matrix */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5)+1; /* assignment */

#ifdef DEBUG_MAP
 {
     int k; PDL_Indx foo = 0;
     printf("ovec: [");
     for(k=0;k<ndims;k++) {
       foo += ovec[k] * map->dimincs[k+1];
       printf(" %2d ",(int)(ovec[k]));
     }
     printf("]; psize is %ld; big is %d; blur is %8.2f; map is [",psize,big, blur);
     for(k=0;k<ndims;k++) {
       printf("%8.2f",(double)(((PDL_LDouble *)(map->data))[foo + k*map->dimincs[0]]));
     }
     printf("]\n");
 }
#endif

   /* Don't bother accumulating output if psize is too large */
   if(psize <= big) {
     /* Use the prefrobnicated matrix to generate a local linearization.
      * dvec gets the delta; ibvec gets the base.
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
        dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
        mp += map->dimincs[0];
       }
     }

     /* Initialize input delta vector  */
     for(i=0;i<ndims;i++)
       ivec[i] = -psize;

     /* Initialize accumulators */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)	
         *(ac++) = 0.0;		     

     }
     {
       PDL_Double *wg = wgt;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
     }
     {
       PDL_Double *wg = wgt2;
       for(i=0;i < in->dims[ndims]; i++)
         *(wg++) = 0.0;
      }	  


     /*
      * Calculate the original offset into the data array, to enable
      * delta calculations in the pixel loop
      *
      * i runs over dims; j holds the working integer index in the
      * current dim.
      *
      * This code matches the incrementation code at the bottom of the accumulation loop
      */
      
     t_vio = 0; /* truncation-boundary violation count - don't bother if it is nonzero */
     i_off = 0;
     for(i=0;i<ndims; i++) {
       j = ivec[i] + ibvec[i];
       if(j<0 || j >= in->dims[i]) {
         switch(bounds[i]) {
         case 0: /* no breakage allowed */
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","index out-of-bounds in map")
#line 9458 "../../blib/lib/PDL/PP.pm"
;
           break;
         case 1: /* truncation */
           t_vio++;
           /* fall through */
         case 2: /* extension -- crop */
           if(j<0)
             j=0;
           else              j = in->dims[i] - 1;
           break;
         case 3: /* periodic -- mod it */
           j %= in->dims[i];
           if(j<0)
             j += in->dims[i];
           break;
         case 4: /* mirror -- reflect off the edges */
           j += in->dims[i];
           j %= (in->dims[i]*2);
           if(j<0)
             j += in->dims[i]*2;
           j -= in->dims[i];
           if(j<0) {
             j *= -1;
             j -= 1;
           }
           break;
         default:
           
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s","Unknown boundary condition in map -- bug alert!")
#line 9489 "../../blib/lib/PDL/PP.pm"
;
           break;
         }
       }
       i_off += in->dimincs[i] * j;
     }

     /* Initialize index stashes for later reference as we scan the footprint */
     /* It's a pain in the ass to deal with boundaries, and doubly so at the  */
     /* end of a dimensional scan.  So we stash the index location at the     */
     /* start of each dimensional scan here.  When we finish incrementing     */
     /* through a particular dim, we pull its value back out of the stash.    */
     for(i=0;i<ndims;i++) {
       index_stash[i] = i_off; 
    }

     /* The input accumulation loop is the hotspot for the entire operation.        */
     /* We loop over pixels in the region of interest (+/- psize in each dimension) */
     /* in the input array, use the linearized transform to bring each pixel center */
     /* forward to the output plane, and calculate a weighting based on the chosen  */
     /* filter function.   'h' is a fast Hanning window rolloff using a lookup      */
     /* table that is initialized the first time through the code.  'H' is the      */
     /* same process, but explicitly calculated for each interation (~2x slower).   */
     /* 'g' uses a radial Gaussian filter.  Rather than calculate the array offset  */
     /* into the input array fresh from the current input array vector each time,   */
     /* we walk through the array using dimincs and the old offset.  This saves     */
     /* about half of the time spent on index calculation.                          */

     do {  /* Input accumulation loop */
         PDL_Double *cp;
         PDL_Double alpha; 
       /* Calculate the weight of the current input point.  Don't bother if we're
        * violating any truncation boundaries (in that case our value is zero, but
        * for the interpolation we also set the weight to zero).
        */
       if( !t_vio ) {

         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Indx   *ip = ivec;
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);

         switch(method) {
           PDL_Double dd; 
         case 'h':
           /* This is the Hanning window rolloff.  It is a product of a simple */
           /* cos^2(theta) rolloff in each dimension.  Using a lookup table    */
           /* is about 2x faster than using cos(theta) directly in each        */
           /* weighting calculation, so we do.  Using 2500 entries and linear  */
           /* interpolation is accurate to about 10^-7, and should preserve    */
           /* the contents of cache pretty well.                               */
           alpha = 1;
           cp = tmp;
           for(i=0; i<ndims; i++) {
             int lodex;
             int hidex;
             PDL_Double beta;
              dd = 0;
             ap = tvec;
             /* Get the matrix-multiply element for this dimension */
             for(j=0;j<ndims; j++)
               dd += *(ap++) * *(cp++);

             /* Do linear interpolation from the table */
             /* The table captures a hanning window centered 0.5 pixel from center. */
             /* We scale the filter by the blur parameter -- but if blur is less    */
             /* than unity, we shrink the hanning blur window while keeping the 0.5 */
             /* value on the pixel edge at 0.5.  For blur greater than unity, we    */
             /* scale simply. */
             beta = fabs(dd) - hanning_offset;
             if(beta > 0) {
               if(beta >= blur) {
                 alpha = 0;
                 i = ndims;
               } else {
                 beta *= zeta;
                 lodex = beta;
                 beta -= lodex;                   if(lodex > HANNING_LOOKUP_SIZE)
                 lodex = HANNING_LOOKUP_SIZE;
                 hidex = lodex+1;
                                  alpha *= hanning_lookup[hidex]*beta + hanning_lookup[lodex]*(1-beta);
               } /* end of interpolation branch */
             } /* end of beta > 0 branch */
           } /* end of dimension loop */
         break;

        case 'H':
          /* This is the Hanning window rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
               alpha = 1;
               cp = tmp;
               for(i=0; i<ndims; i++) {
                 dd = 0;
                 ap = tvec;
                 for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                 dd = (fabs(dd) - hanning_offset) / blur;
                 if( dd > 1 ) {
                     alpha = 0;
                     i = ndims;
                 } else
                     alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));
               }
              break;

	case 'g':
	  /* This is the Gaussian rolloff.  It does lookup into a precalculated exponential. */
	  {
	    PDL_Double sum = 0;
	    cp = tmp;
	    for(i=0; i<ndims;i++) {
	      dd = 0;
              ap = tvec;
	      for(j=0;j<ndims;j++)
	        dd += *(ap++) * *(cp++);
	      dd /= blur;
	      sum += dd * dd;
	      if(sum > GAUSSIAN_MAXVAL) {
		  i = ndims; /* exit early if we're too far out */
		  alpha = 0;
              }
	    }
	    if( sum > GAUSSIAN_MAXVAL || !isfinite(sum) || isnan(sum) ) {
	      alpha = 0;
	    } else {
	      int lodex,hidex;
	      PDL_Double beta = fabs(zeta * sum);

	      lodex = beta;
	      beta -= lodex; 	      hidex = lodex+1;
	                    alpha = gaussian_lookup[hidex]*beta + gaussian_lookup[lodex]*(1 - beta);

            }
          }
          break;

        case 'G':
          /* This is the Gaussian rolloff with explicit calculation, preserved */
          /* in case someone actually wants the slower longer method. */
              {
                 PDL_Double sum = 0;
                 cp = tmp;
                 for(i=0; i<ndims; i++) {
                   dd = 0;
                   ap = tvec;
                   for(j=0;j<ndims; j++)
                     dd += *(ap++) * *(cp++);
                   dd /= blur;
                   sum += dd * dd;
                   if(sum > 4) /* 2 pixels -- four half-widths */
                    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
                 }

                 if(sum > GAUSSIAN_MAXVAL)
                   alpha = 0;
                 else
                   alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
              }
              break;
         default:
           {
             char buf[80];
             sprintf(buf,"This can't happen: method='%c'",method);
             
#line 385 "../../blib/lib/PDL/PP.pm"
return PDL->make_error(PDL_EUSERERROR, "Error in map:" "%s",buf)
#line 9657 "../../blib/lib/PDL/PP.pm"
;
           }
         }

         {  /* convenience block -- accumulate the current point into the weighted sum.  */
            /* This is more than simple assignment because we have our own explicit poor */
            /* man's broadcastloop here, so we accumulate each broadcasted element separately. */
            PDL_LDouble *dat = ((PDL_LDouble *)(in->data)) + i_off;
            PDL_Indx max = out->dims[ndims];
            for( i=0; i < max; i++ ) {
	      if( (badval==0) || (*dat != badval) ) {
                 acc[i] += *dat * alpha;
                 dat += in->dimincs[ndims];
	         wgt[i] += alpha;
	      }
	      wgt2[i] += alpha;              }
          }
       } /* end of t_vio check (i.e. of input accumulation) */


       /* Advance input accumulation loop.  */
       /* We both increment the total vector and also advance the index. */
       carry = 1;
       for(i=0; i<ndims && carry; i++) {
         /* Advance the current element of the offset vector */
         ivec[i]++;
         j = ivec[i] + ibvec[i];

         /* Advance the offset into the data array */
         if( j > 0 && j <= in->dims[i]-1 ) {
            /* Normal case -- just advance the input vector */
            i_off += in->dimincs[i];
         } else {
            /* Busted a boundary - either before or after.  */
            switch(bounds[i]){
            case 0: /* no breakage allowed -- treat as truncation for interpolation */
            case 1: /* truncation -- if we crossed the boundary mark ourselves out-of-bounds */
              if( j == 0 )
                t_vio--;
              else if( j == in->dims[i] )
                t_vio++;
              break;
             case 2: /* extension -- do nothing (so the same input point is re-used) */
               break;
             case 3: /* periodic  -- advance and mod into the allowed range */
               if((j % in->dims[i]) == 0) {
                 i_off -= in->dimincs[i] * (in->dims[i]-1);
               } else {
                 i_off += in->dimincs[i];
               }
               break;
            case 4: /* mirror -- advance or retreat depending on phase */
               j += in->dims[i];
               j %= (in->dims[i]*2);
               j -= in->dims[i];
               if( j!=0 && j!= -in->dims[i] ) {
                 if(j<0)
                   i_off -= in->dimincs[i];
                 else
                   i_off += in->dimincs[i];
               }
               break;
            }
         }

         /* Now check for carry */
         if(ivec[i] <= psize) {
           /* Normal case -- copy the current offset to the faster-running dim stashes */
           int k;
           for(k=0;k<i;k++) {
             index_stash[k] = i_off;
           }
           carry = 0;

         } else { /* End of this scan -- recover the last position, and mark carry */
           i_off = index_stash[i];
           if(bounds[i]==1) {
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio--;
             ivec[i] = -psize;
             j = ivec[i] + ibvec[i];
             if( j < 0 || j >= in->dims[i] )
               t_vio++;
             carry = 1;
           } else {
             ivec[i] = -psize;
           }
         }
       } /* End of counter-advance loop */
     } while(carry==0);  /* end of total data accumulation loop (termination condition has carry on last dim) */

     {
       PDL_Double *ac = acc;
       PDL_Double *wg = wgt;
       PDL_Double *wg2 = wgt2;
       PDL_LDouble *dat = out->data;

       /* Calculate output vector offset */
       for(i=0;i<ndims;i++)
         dat += out->dimincs[i] * ovec[i];

       if(!flux) {
         /* Flux flag is NOT set -- normal case.  Copy the weighted accumulated data. */
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++);
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
              dat += out->dimincs[ndims];
         }
       } else {
         /* Flux flag is set - scale by the (unpadded) determinant of the Jacobian */
         PDL_Double det = tmp[ndims*ndims];
         for(i=0; i < out->dims[ndims]; i++) {
	   if(*wg && (*wg2 / *wg) < 1.5 ) {
              *dat = *(ac++) / *(wg++) * det;
	      wg2++;
           } else {
	      *dat = badval;
	      ac++; wg++; wg2++;
	   }
           dat += out->dimincs[ndims];
         } /* end of for loop */
       } /* end of flux flag set conditional */
     } /* end of convenience block */
     
     /* End of code for normal pixels */
   } else {
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_LDouble *dat = out->data;
      for(i=0;i<ndims;i++)
        dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
        *dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     for(i=0;
             (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
             (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
         i++) {
        ovec[i] = 0;
        map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}PDL_BROADCASTLOOP_END(
__privtrans->broadcast,
k0_datap -= __tinc1_k0 * __tdims1 + __offsp[0];

)

#undef PDL_IF_GENTYPE_INTEGER
#undef PDL_IF_GENTYPE_REAL
#undef PDL_IF_GENTYPE_UNSIGNED

#line 522 "../../blib/lib/PDL/PP/PDLCode.pm"
} break;
#line 9827 "../../blib/lib/PDL/PP.pm"

	default:return PDL->make_error(PDL_EUSERERROR, "PP INTERNAL ERROR in map: unhandled datatype(%d), only handles (ABSULKNPQFDE)! PLEASE MAKE A BUG REPORT\n", __privtrans->__datatype);}

  return PDL_err;
}
#line 8307 "pp-map.c"



#line 1990 "../../blib/lib/PDL/PP.pm"
static pdl_datatypes pdl_map_vtable_gentypes[] = { PDL_SB, PDL_B, PDL_S, PDL_US, PDL_L, PDL_UL, PDL_IND, PDL_ULL, PDL_LL, PDL_F, PDL_D, PDL_LD, -1 };
static char pdl_map_vtable_flags[] = {
  PDL_TPDL_VAFFINE_OK
};
static PDL_Indx pdl_map_vtable_realdims[] = { 0 };
static char *pdl_map_vtable_parnames[] = { "k0" };
static short pdl_map_vtable_parflags[] = {
  0
};
static pdl_datatypes pdl_map_vtable_partypes[] = { -1 };
static PDL_Indx pdl_map_vtable_realdims_starts[] = { 0 };
static PDL_Indx pdl_map_vtable_realdims_ind_ids[] = { 0 };
static char *pdl_map_vtable_indnames[] = { "" };
pdl_transvtable pdl_map_vtable = {
  PDL_TRANS_DO_BROADCAST, 0, pdl_map_vtable_gentypes, 1, 1, pdl_map_vtable_flags,
  pdl_map_vtable_realdims, pdl_map_vtable_parnames,
  pdl_map_vtable_parflags, pdl_map_vtable_partypes,
  pdl_map_vtable_realdims_starts, pdl_map_vtable_realdims_ind_ids, 0,
  0, pdl_map_vtable_indnames,
  NULL, pdl_map_readdata, NULL,
  NULL,
  sizeof(pdl_params_map),"PDL::Transform::map"
};
#line 8335 "pp-map.c"



#line 1933 "../../blib/lib/PDL/PP.pm"
pdl_error pdl_map_run(pdl  *k0,pdl  *in,pdl  *out,pdl  *map,SV  *boundary,SV  *method,long  big,double  blur,double  sv_min,char  flux,SV  *bv) {
pdl_error PDL_err = {0, NULL, 0};

#line 1908 "../../blib/lib/PDL/PP.pm"
if (!PDL) return (pdl_error){PDL_EFATAL, "PDL core struct is NULL, can't continue",0};
pdl_trans *__privtrans = PDL->create_trans(&pdl_map_vtable);
if (!__privtrans) return PDL->make_error_simple(PDL_EFATAL, "Couldn't create trans");
pdl_params_map *__params = __privtrans->params;
#line 1941 "../../blib/lib/PDL/PP.pm"

#line 1744 "../../blib/lib/PDL/PP.pm"
__privtrans->pdls[0] = k0;
#line 1945 "../../blib/lib/PDL/PP.pm"

#line 1868 "../../blib/lib/PDL/PP.pm"
PDL_RETERROR(PDL_err, PDL->trans_check_pdls(__privtrans));
char 
#line 392 "../../blib/lib/PDL/PP.pm"
badflag_cache
#line 1872 "../../blib/lib/PDL/PP.pm"
 = PDL->trans_badflag_from_inputs(__privtrans);
#line 1954 "../../blib/lib/PDL/PP.pm"

#line 1736 "../../blib/lib/PDL/PP.pm"
PDL_RETERROR(PDL_err, PDL->type_coerce(__privtrans));
#line 1958 "../../blib/lib/PDL/PP.pm"

#line 1752 "../../blib/lib/PDL/PP.pm"
k0 = __privtrans->pdls[0];
#line 1962 "../../blib/lib/PDL/PP.pm"

#line 169 "../../blib/lib/PDL/PP/Signature.pm"
(__params->in) = (in);(__params->out) = (out);(__params->map) = (map);(__params->boundary) = newSVsv(boundary);(__params->method) = newSVsv(method);(__params->big) = (big);(__params->blur) = (blur);(__params->sv_min) = (sv_min);(__params->flux) = (flux);(__params->bv) = newSVsv(bv);
#line 1966 "../../blib/lib/PDL/PP.pm"

#line 1758 "../../blib/lib/PDL/PP.pm"
PDL_RETERROR(PDL_err, PDL->make_trans_mutual(__privtrans));
#line 1970 "../../blib/lib/PDL/PP.pm"

#line 1892 "../../blib/lib/PDL/PP.pm"
if (
#line 392 "../../blib/lib/PDL/PP.pm"
badflag_cache
#line 1895 "../../blib/lib/PDL/PP.pm"
) {
}
#line 1979 "../../blib/lib/PDL/PP.pm"
return PDL_err;
}
#line 8389 "pp-map.c"
